VTK: vtkExporter Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkExporter Class Referenceabstract

abstract class to write a scene to a file More...

`#include <vtkExporter.h>`

Inheritance diagram for vtkExporter:
[legend]
Collaboration diagram for vtkExporter:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkExporter * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | Write ()
| Write data to output. More...
void | Update ()
| Convenient alias for Write() method. More...
void | SetStartWrite (void(*f)(void *), void *arg)
| Specify a function to be called before data is written. More...
void | SetEndWrite (void(*f)(void *), void *arg)
| Specify a function to be called after data is written. More...
void | SetStartWriteArgDelete (void(*f)(void *))
| Set the arg delete method. More...
void | SetEndWriteArgDelete (void(*f)(void *))
| Set the arg delete method. More...
vtkMTimeType | GetMTime () override
| Returns the MTime also considering the RenderWindow. More...
virtual void | SetRenderWindow (vtkRenderWindow *)
| Set/Get the rendering window that contains the scene to be written. More...
virtual vtkRenderWindow * | GetRenderWindow ()
| Set/Get the rendering window that contains the scene to be written. More...
virtual void | SetActiveRenderer (vtkRenderer *)
| Set/Get the renderer that contains actors to be written. More...
virtual vtkRenderer * | GetActiveRenderer ()
| Set/Get the renderer that contains actors to be written. More...
void | SetInput (vtkRenderWindow *renWin)
| These methods are provided for backward compatibility. More...
vtkRenderWindow * | GetInput ()
| These methods are provided for backward compatibility. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkExporter * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkExporter ()
| ~vtkExporter () override
virtual void | WriteData ()=0
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkRenderWindow * | RenderWindow
vtkRenderer * | ActiveRenderer
void(* | StartWrite )(void *)
void(* | StartWriteArgDelete )(void *)
void * | StartWriteArg
void(* | EndWrite )(void *)
void(* | EndWriteArgDelete )(void *)
void * | EndWriteArg
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

abstract class to write a scene to a file

vtkExporter is an abstract class that exports a scene to a file. It is very similar to vtkWriter except that a writer only writes out the geometric and topological data for an object, where an exporter can write out material properties, lighting, camera parameters etc. The concrete subclasses of this class may not write out all of this information. For example vtkOBJExporter writes out Wavefront obj files which do not include support for camera parameters.

vtkExporter provides the convenience methods StartWrite() and EndWrite(). These methods are executed before and after execution of the Write() method. You can also specify arguments to these methods. This class defines SetInput and GetInput methods which take or return a vtkRenderWindow.

Warning
  Every subclass of vtkExporter must implement a WriteData() method.

See also
  vtkOBJExporter vtkRenderWindow vtkWriter

Definition at line 36 of file vtkExporter.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkExporter::Superclass

Definition at line 39 of file vtkExporter.h.

## Constructor & Destructor Documentation

## ◆ vtkExporter()

vtkExporter::vtkExporter | ( |  | ) |
| protected

## ◆ ~vtkExporter()

vtkExporter::~vtkExporter | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkExporter::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkExporter::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

Reimplemented in vtkPVWebGLExporter, vtkPDFExporter, vtkOpenGLGL2PSExporter, vtkGL2PSExporter, vtkX3DExporter, vtkVRMLExporter, vtkSVGExporter, vtkSingleVTPExporter, vtkRIBExporter, vtkPOVExporter, vtkOOGLExporter, vtkOBJExporter, vtkJSONSceneExporter, vtkJSONRenderWindowExporter, vtkIVExporter, and vtkGLTFExporter.

## ◆ SafeDownCast()

static vtkExporter* vtkExporter::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkExporter::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented in vtkPVWebGLExporter, vtkPDFExporter, vtkOpenGLGL2PSExporter, vtkGL2PSExporter, vtkX3DExporter, vtkVRMLExporter, vtkSVGExporter, vtkSingleVTPExporter, vtkRIBExporter, vtkPOVExporter, vtkOOGLExporter, vtkOBJExporter, vtkJSONSceneExporter, vtkJSONRenderWindowExporter, vtkIVExporter, and vtkGLTFExporter.

## ◆ NewInstance()

vtkExporter* vtkExporter::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkExporter::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

Reimplemented in vtkPVWebGLExporter, vtkPDFExporter, vtkOpenGLGL2PSExporter, vtkGL2PSExporter, vtkX3DExporter, vtkVRMLExporter, vtkSVGExporter, vtkSingleVTPExporter, vtkRIBExporter, vtkPOVExporter, vtkOOGLExporter, vtkOBJExporter, vtkJSONSceneExporter, vtkJSONRenderWindowExporter, vtkIVExporter, and vtkGLTFExporter.

## ◆ Write()

virtual void vtkExporter::Write | ( |  | ) |
| virtual

Write data to output.

Method executes subclasses WriteData() method, as well as StartWrite() and EndWrite() methods.

## ◆ Update()

void vtkExporter::Update | ( |  | ) |

Convenient alias for Write() method.

## ◆ SetRenderWindow()

virtual void vtkExporter::SetRenderWindow | ( | vtkRenderWindow * |  | ) |
| virtual

Set/Get the rendering window that contains the scene to be written.

## ◆ GetRenderWindow()

virtual vtkRenderWindow* vtkExporter::GetRenderWindow | ( |  | ) |
| virtual

Set/Get the rendering window that contains the scene to be written.

## ◆ SetActiveRenderer()

virtual void vtkExporter::SetActiveRenderer | ( | vtkRenderer * |  | ) |
| virtual

Set/Get the renderer that contains actors to be written.

If it is set to nullptr (by default), then in most subclasses the behavior is to only export actors of the first renderer. In some subclasses, if ActiveRenderer is nullptr then actors of all renderers will be exported. The renderer must be in the renderer collection of the specified RenderWindow.

See also
  SetRenderWindow()

## ◆ GetActiveRenderer()

virtual vtkRenderer* vtkExporter::GetActiveRenderer | ( |  | ) |
| virtual

Set/Get the renderer that contains actors to be written.

If it is set to nullptr (by default), then in most subclasses the behavior is to only export actors of the first renderer. In some subclasses, if ActiveRenderer is nullptr then actors of all renderers will be exported. The renderer must be in the renderer collection of the specified RenderWindow.

See also
  SetRenderWindow()

## ◆ SetInput()

void vtkExporter::SetInput | ( | vtkRenderWindow * | renWin | ) |
| inline

These methods are provided for backward compatibility.

Will disappear soon.

Definition at line 81 of file vtkExporter.h.

## ◆ GetInput()

vtkRenderWindow* vtkExporter::GetInput | ( |  | ) |
| inline

These methods are provided for backward compatibility.

Will disappear soon.

Definition at line 82 of file vtkExporter.h.

## ◆ SetStartWrite()

void vtkExporter::SetStartWrite | ( | void(*)(void *) | f,
|  | void * | arg
| ) |  |

Specify a function to be called before data is written.

Function will be called with argument provided.

## ◆ SetEndWrite()

void vtkExporter::SetEndWrite | ( | void(*)(void *) | f,
|  | void * | arg
| ) |  |

Specify a function to be called after data is written.

Function will be called with argument provided.

## ◆ SetStartWriteArgDelete()

void vtkExporter::SetStartWriteArgDelete | ( | void(*)(void *) | f | ) |

Set the arg delete method.

This is used to free user memory.

## ◆ SetEndWriteArgDelete()

void vtkExporter::SetEndWriteArgDelete | ( | void(*)(void *) | f | ) |

Set the arg delete method.

This is used to free user memory.

## ◆ GetMTime()

vtkMTimeType vtkExporter::GetMTime | ( |  | ) |
| overridevirtual

Returns the MTime also considering the RenderWindow.

Reimplemented from vtkObject.

## ◆ WriteData()

virtual void vtkExporter::WriteData | ( |  | ) |
| protectedpure virtual

Implemented in vtkPVWebGLExporter, vtkPDFExporter, vtkOpenGLGL2PSExporter, vtkX3DExporter, vtkVRMLExporter, vtkSVGExporter, vtkSingleVTPExporter, vtkRIBExporter, vtkPOVExporter, vtkOOGLExporter, vtkOBJExporter, vtkJSONSceneExporter, vtkJSONRenderWindowExporter, vtkIVExporter, and vtkGLTFExporter.

## Member Data Documentation

## ◆ RenderWindow

vtkRenderWindow* vtkExporter::RenderWindow
| protected

Definition at line 116 of file vtkExporter.h.

## ◆ ActiveRenderer

vtkRenderer* vtkExporter::ActiveRenderer
| protected

Definition at line 117 of file vtkExporter.h.

## ◆ StartWrite

void(* vtkExporter::StartWrite) (void *)
| protected

Definition at line 120 of file vtkExporter.h.

## ◆ StartWriteArgDelete

void(* vtkExporter::StartWriteArgDelete) (void *)
| protected

Definition at line 121 of file vtkExporter.h.

## ◆ StartWriteArg

void* vtkExporter::StartWriteArg
| protected

Definition at line 122 of file vtkExporter.h.

## ◆ EndWrite

void(* vtkExporter::EndWrite) (void *)
| protected

Definition at line 123 of file vtkExporter.h.

## ◆ EndWriteArgDelete

void(* vtkExporter::EndWriteArgDelete) (void *)
| protected

Definition at line 124 of file vtkExporter.h.

## ◆ EndWriteArg

void* vtkExporter::EndWriteArg
| protected

Definition at line 125 of file vtkExporter.h.

The documentation for this class was generated from the following file:

- IO/Export/vtkExporter.h